#
# General Perl functions
#
# Copyright 2000 Wilmer van der Gaast (lintux@lintux.cx)
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-#1307 USA
#

sub get_param
{
	if( $ENV{ QUERY_STRING } eq "" )
	{
		return( "" );
	}
	@params = split( "&", $ENV{ QUERY_STRING } );
	
	for $i (0..$#params)
	{
		if( $_[0] eq ( split( "=", $params[$i] ) )[0] )
		{
			$result = ( split( "=", $params[$i] ) )[1];
			$result =~ s/%09/	/g;
			$result =~ s/%0D//g;
			$result =~ s/\+/\ /g;
			$result =~ s/%21/\!/g;
			$result =~ s/%22/\"/g;
			$result =~ s/%23/\#/g;
			$result =~ s/%24/\$/g;
			$result =~ s/%26/\&/g;
			$result =~ s/%27/\'/g;
			$result =~ s/%28/\(/g;
			$result =~ s/%29/\)/g;
			$result =~ s/%2B/\+/g;
			$result =~ s/%2C/\,/g;
			$result =~ s/%2F/\//g;
			$result =~ s/%3A/\:/g;
			$result =~ s/%3B/\;/g;
			$result =~ s/%3C/\</g;
			$result =~ s/%3D/\=/g;
			$result =~ s/%3E/\>/g;
			$result =~ s/%3F/\?/g;
			$result =~ s/%40/\@/g;
			$result =~ s/%5B/\[/g;
			$result =~ s/%5C/\\\\/g;
			$result =~ s/%5D/\]/g;
			$result =~ s/%5E/\^/g;
			$result =~ s/%60/\`/g;
			$result =~ s/%7B/\{/g;
			$result =~ s/%7C/\|/g;
			$result =~ s/%7D/\}/g;
			$result =~ s/%7E/\~/g;
			$result =~ s/%25/\%/g;
			return( $result );
		}
	}
}

sub put_begin
{
	print <<EOF;
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>$_[0]</TITLE>
</HEAD>
<BODY BGCOLOR=$COLOR_BACK>
EOF
}

sub put_end
{
	@filename = split( "/", $0 );
	$filename = $filename[ scalar( @filename ) - 1 ];
	print <<EOF;

<TABLE BORDER=0 CELLSPACING=0 WIDTH=100%>
	<TR>
		<TD HEIGHT=20>
		</TD>
	</TR>
	<TR>
		<TH BGCOLOR=$COLOR_HEAD_BACK ALIGN=CENTER>
			<FONT COLOR=$COLOR_HEAD_FORE><TT>$filename:</TT> &copy; Copyright 2000 <A HREF="http://www.lintux.cx/">Wilmer van der Gaast</A></FONT>
		</TH>
	</TR>
</TABLE>
EOF
	
	if( $CGI_HOSTEDBY eq "yes" )
	{
		print <<EOF;

<TABLE BORDER=0 CELLSPACING=0 WIDTH=100%>
	<TR>
		<TD HEIGHT=10>
		</TD>
	</TR>
	<TR>
		<TH BGCOLOR=$COLOR_HEAD_BACK ALIGN=CENTER>
			<FONT COLOR=$COLOR_HEAD_FORE>This page is hosted by</FONT>
		</TH>
	</TR>
	<TR>
		<TD BGCOLOR=$COLOR_SUBH_BACK HEIGHT=5>
		</TD>
	</TR>
	<TR>
		<TD BGCOLOR=$COLOR_TEXT_BACK ALIGN=CENTER>
$CGI_HOSTEDBY_STRING
		</TD>
	</TR>
</TABLE>
EOF
	}
	print <<EOF;

</BODY>
</HTML>
EOF
}

sub inet_address_to_name
{
	$rev_ip = join( ".", reverse( split( "\\.", $_[0] ) ) );
	@out = `$DNSQUERY_COMMAND $rev_ip.in-addr.arpa`;
	if( $? == 0 )
	{
		$name = ( grep( /.*IN *PTR */, @out ) )[0];
		chomp( $name );
		$name =~ s/.*IN *PTR *//i;
		$name =~ s/\.$//i;
		if( $name eq "" )
		{
			return( "Unknown" );
		}
		else
		{
			return( $name );
		}
	}
	else
	{
		return( "Unknown" );
	}
}

return( 1 );	# Prevent 'functions.pl doesn't return positive value' error
