#!/usr/bin/perl
#
# Boter, kaas en eieren (a.k.a. Tic Tac Toe in English)
#
# Copyright 2000 Wilmer van der Gaast (lintux@lintux.cx)
# 
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-#1307 USA
# 

$CGI_ROOT = $ENV{ "SCRIPT_FILENAME" };
$CGI_ROOT =~ s/\/[^\/]*$//i;
$CGI_REMOTE_ROOT = $ENV{ "SCRIPT_NAME" };
$CGI_REMOTE_ROOT =~ s/\/[^\/]*$//i;

# Subs
require( $CGI_ROOT . "/functions.pl" );
require( $CGI_ROOT . "/ttt_functions.pl" );

# Configuration
require( $CGI_ROOT . "/ttt.conf" );

@moves = split( "", get_param( "moves" ) );
$turn = get_param( "start" );

for $i ( 0 .. scalar( @moves ) - 1 )
{
	$field[$moves[$i]] = $turn;
	$turn = 3 - $turn;
}

if( get_param( "moves" ) eq "" )
	{ }
elsif( move_win( substr( get_param( "moves" ), -1 ) ) == 1 )
	{ $end = 1; }
else
	{ $end = 0; }

# AI is here:
if( get_param( "ai" ) ne "skip" and $end != 1 )
{
	$moves = get_param( "moves" ) . $best;
	if( $moves eq "1" or $moves eq "3" or $moves eq "7" or $moves eq "9" )
	{
		$best = 5;
	}
	else
	{
		$win = 0;
		for $i ( 1 .. 9 )
		{
			if( $field[$i] != 0 )
				{ next; }
			
			$rate[$i] = move_rate( 1 );
		}
		
		if( $win == 0 )
		{
			$turn = 3 - $turn;
			for $i ( 1 .. 9 )
			{
				if( $field[$i] != 0 )
					{ next; }
				
				$rate[$i] += 2 * move_rate( 1 );
			}
			$turn = 3 - $turn;
		}
		
		$best = 0;
		for $i ( 1 .. 9 )
		{
			if( $field[$i] != 0 )
				{ }
			elsif( $rate[$i] > $rate[$best] or $best == 0 )
				{ $best = $i; }
			elsif( $rate[$i] == $rate[$best] and int( rand( 10 ) ) > 7 )
				{ $best = $i; }
		}
	}
	
	$moves = $moves . $best;
	$field[$best] = $turn;
	
	if( move_win( $best ) == 1 )
		{ $end = 1; }
}
else	
{
	$moves = get_param( "moves" );
}

put_board();
